extern "C" {
    typedef long unsigned int size_t;
    typedef struct
    {
    }
    _IO_cookie_io_functions_t;
}
namespace std
{
typedef long unsigned int size_t;
void __throw_bad_alloc(void) __attribute__((__noreturn__));
template<typename _Tp> inline _Tp* __addressof(_Tp& __r)
{
}
template<class _T1, class _T2> struct pair
{
    typedef _T1 first_type;
    _T1 first;
    _T2 second;
    pair(const _T1& __a, const _T2& __b) : first(__a), second(__b)
    {
    }
};
template<typename _Tp> inline const _Tp& min(const _Tp& __a, const _Tp& __b)
{
}
template<typename _CharT> struct char_traits;
}
extern "C++" {
    inline void* operator new(std::size_t, void* __p) throw()
    {
    }
}
namespace __gnu_cxx __attribute__ ((__visibility__ ("default")))
{
template<typename _Tp> class new_allocator
{
public:
    typedef size_t size_type;
    typedef _Tp* pointer;
    typedef _Tp& reference;
    pointer allocate(size_type __n, const void* = 0)
    {
        if (__n > this->max_size()) std::__throw_bad_alloc();
        return static_cast<_Tp*>(::operator new(__n * sizeof(_Tp)));
    }
    size_type max_size() const throw()
    {
    }
    void construct(pointer __p, const _Tp& __val)
    {
        ::new((void *)__p) _Tp(__val);
    }
};
}
namespace std __attribute__ ((__visibility__ ("default")))
{
template<typename _Tp> class allocator: public __gnu_cxx::new_allocator<_Tp>
{
public:
    typedef size_t size_type;
    template<typename _Tp1> struct rebind
    {
        typedef allocator<_Tp1> other;
    };
};
template<typename _CharT, typename _Traits = char_traits<_CharT>, typename _Alloc = allocator<_CharT> > class basic_string;
typedef basic_string<char> string;
typedef struct __locale_struct
{
}
*__locale_t;
template<> struct char_traits<char>
{
    typedef char char_type;
    static int compare(const char_type* __s1, const char_type* __s2, size_t __n)
    {
        return __builtin_memcmp(__s1, __s2, __n);
    }
};
template<typename _Arg, typename _Result> struct unary_function
{
};
template<typename _Arg1, typename _Arg2, typename _Result> struct binary_function
{
};
template<typename _Tp> struct less : public binary_function<_Tp, _Tp, bool>
{
    bool operator()(const _Tp& __x, const _Tp& __y) const
    {
        return __x < __y;
    }
};
template<typename _Tp> struct _Identity : public unary_function<_Tp,_Tp>
{
    const _Tp& operator()(const _Tp& __x) const
    {
        return __x;
    }
};
template<typename _Pair> struct _Select1st : public unary_function<_Pair, typename _Pair::first_type>
{
    const typename _Pair::first_type& operator()(const _Pair& __x) const
    {
        return __x.first;
    }
};
}
typedef struct
{
}
pthread_rwlock_t;
typedef int _Atomic_word;
namespace __gnu_cxx __attribute__ ((__visibility__ ("default")))
{
static inline _Atomic_word __attribute__ ((__unused__)) __exchange_and_add_dispatch(_Atomic_word* __mem, int __val)
{
}
}
namespace std __attribute__ ((__visibility__ ("default")))
{
template<typename _CharT, typename _Traits, typename _Alloc> class basic_string
{
    typedef typename _Alloc::template rebind<_CharT>::other _CharT_alloc_type;
public:
    typedef _Traits traits_type;
    typedef _Alloc allocator_type;
    typedef typename _CharT_alloc_type::size_type size_type;
    typedef typename _CharT_alloc_type::reference reference;
private:
    struct _Rep_base
    {
        size_type _M_length;
        _Atomic_word _M_refcount;
    };
    struct _Rep : _Rep_base
    {
        bool _M_is_leaked() const
        {
            return this->_M_refcount > 0;
        }
        _CharT* _M_refdata() throw()
        {
        }
        void _M_dispose(const _Alloc& __a)
        {
            if (__builtin_expect(this != &_S_empty_rep(), false))
            {
                if (__gnu_cxx::__exchange_and_add_dispatch(&this->_M_refcount, -1) <= 0)
                {
                    _M_destroy(__a);
                }
            }
        }
        void _M_destroy(const _Alloc&) throw();
    };
    struct _Alloc_hider : _Alloc
    {
        _Alloc_hider(_CharT* __dat, const _Alloc& __a) : _Alloc(__a), _M_p(__dat)
        {
        }
        _CharT* _M_p;
    };
private:
    mutable _Alloc_hider _M_dataplus;
    _CharT* _M_data() const
    {
        return _M_dataplus._M_p;
    }
    _Rep* _M_rep() const
    {
        return &((reinterpret_cast<_Rep*> (_M_data()))[-1]);
    }
    void _M_leak()
    {
        if (!_M_rep()->_M_is_leaked()) _M_leak_hard();
    }
    void _M_leak_hard();
    static _Rep& _S_empty_rep()
    {
    }
public:
    basic_string() : _M_dataplus(_S_empty_rep()._M_refdata(), _Alloc())
    {
    }
    basic_string(const basic_string& __str);
    basic_string(const _CharT* __s, const _Alloc& __a = _Alloc());
    ~basic_string()
    {
        _M_rep()->_M_dispose(this->get_allocator());
    }
public:
    size_type size() const
    {
        return _M_rep()->_M_length;
    }
    size_type length() const
    {
        return _M_rep()->_M_length;
    }
    bool empty() const
    {
        return this->size() == 0;
    }
    reference operator[](size_type __pos)
    {
        _M_leak();
        return _M_data()[__pos];
    }
    basic_string& operator+=(const basic_string& __str)
    {
        return this->append(__str);
    }
    basic_string& append(const basic_string& __str);
    const _CharT* c_str() const
    {
        return _M_data();
    }
    const _CharT* data() const
    {
        return _M_data();
    }
    allocator_type get_allocator() const
    {
    }
    int compare(const basic_string& __str) const
    {
        const size_type __size = this->size();
        const size_type __osize = __str.size();
        const size_type __len = std::min(__size, __osize);
        int __r = traits_type::compare(_M_data(), __str.data(), __len);
        return __r;
    }
};
template<typename _CharT, typename _Traits, typename _Alloc> basic_string<_CharT,_Traits,_Alloc> operator+(const _CharT* __lhs, const basic_string<_CharT,_Traits,_Alloc>& __rhs);
template<typename _CharT, typename _Traits, typename _Alloc> inline basic_string<_CharT, _Traits, _Alloc> operator+(const basic_string<_CharT, _Traits, _Alloc>& __lhs, const _CharT* __rhs)
{
    basic_string<_CharT, _Traits, _Alloc> __str(__lhs);
    __str.append(__rhs);
}
template<typename _CharT, typename _Traits, typename _Alloc> inline bool operator<(const basic_string<_CharT, _Traits, _Alloc>& __lhs, const basic_string<_CharT, _Traits, _Alloc>& __rhs)
{
    return __lhs.compare(__rhs) < 0;
}
struct _Rb_tree_node_base
{
    typedef _Rb_tree_node_base* _Base_ptr;
    typedef const _Rb_tree_node_base* _Const_Base_ptr;
    _Base_ptr _M_parent;
    _Base_ptr _M_left;
    _Base_ptr _M_right;
};
template<typename _Val> struct _Rb_tree_node : public _Rb_tree_node_base
{
    _Val _M_value_field;
};
__attribute__ ((__pure__)) const _Rb_tree_node_base* _Rb_tree_increment(const _Rb_tree_node_base* __x) throw ();
__attribute__ ((__pure__)) _Rb_tree_node_base* _Rb_tree_decrement(_Rb_tree_node_base* __x) throw ();
__attribute__ ((__pure__)) const _Rb_tree_node_base* _Rb_tree_decrement(const _Rb_tree_node_base* __x) throw ();
template<typename _Tp> struct _Rb_tree_iterator
{
    typedef _Tp& reference;
    typedef _Rb_tree_iterator<_Tp> _Self;
    typedef _Rb_tree_node_base::_Base_ptr _Base_ptr;
    typedef _Rb_tree_node<_Tp>* _Link_type;
    explicit _Rb_tree_iterator(_Link_type __x) : _M_node(__x)
    {
    }
    reference operator*() const
    {
    }
    _Self& operator--()
    {
        _M_node = _Rb_tree_decrement(_M_node);
    }
    bool operator==(const _Self& __x) const
    {
        return _M_node == __x._M_node;
    }
    _Base_ptr _M_node;
};
template<typename _Tp> struct _Rb_tree_const_iterator
{
    typedef _Rb_tree_iterator<_Tp> iterator;
    typedef _Rb_tree_const_iterator<_Tp> _Self;
    typedef _Rb_tree_node_base::_Const_Base_ptr _Base_ptr;
    _Rb_tree_const_iterator(const iterator& __it) : _M_node(__it._M_node)
    {
    }
    _Self& operator++()
    {
        _M_node = _Rb_tree_increment(_M_node);
    }
    _Self& operator--()
    {
        _M_node = _Rb_tree_decrement(_M_node);
    }
    bool operator!=(const _Self& __x) const
    {
        return _M_node != __x._M_node;
    }
    _Base_ptr _M_node;
};
template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val> > class _Rb_tree
{
    typedef typename _Alloc::template rebind<_Rb_tree_node<_Val> >::other _Node_allocator;
protected:
    typedef _Rb_tree_node_base* _Base_ptr;
    typedef const _Rb_tree_node_base* _Const_Base_ptr;
public:
    typedef _Key key_type;
    typedef _Val value_type;
    typedef const value_type& const_reference;
    typedef _Rb_tree_node<_Val>* _Link_type;
    typedef const _Rb_tree_node<_Val>* _Const_Link_type;
    typedef size_t size_type;
    typedef _Alloc allocator_type;
    allocator_type get_allocator() const
    {
    }
protected:
    _Link_type _M_get_node()
    {
        return _M_impl._Node_allocator::allocate(1);
    }
    _Link_type _M_create_node(const value_type& __x)
    {
        _Link_type __tmp = _M_get_node();
        try
        {
            get_allocator().construct (std::__addressof(__tmp->_M_value_field), __x);
        }
        catch(...)
        {
            throw;
        }
    }
protected:
    template<typename _Key_compare, bool _Is_pod_comparator = __is_pod(_Key_compare)> struct _Rb_tree_impl : public _Node_allocator
    {
        _Key_compare _M_key_compare;
        _Rb_tree_node_base _M_header;
        size_type _M_node_count;
    };
    _Rb_tree_impl<_Compare> _M_impl;
    _Base_ptr& _M_leftmost()
    {
    }
    _Const_Base_ptr _M_rightmost() const
    {
        return this->_M_impl._M_header._M_right;
    }
    _Link_type _M_begin()
    {
        return static_cast<_Link_type>(this->_M_impl._M_header._M_parent);
    }
    _Link_type _M_end()
    {
        return static_cast<_Link_type>(&this->_M_impl._M_header);
    }
    static _Link_type _S_left(_Base_ptr __x)
    {
        return static_cast<_Link_type>(__x->_M_left);
    }
    static _Link_type _S_right(_Base_ptr __x)
    {
        return static_cast<_Link_type>(__x->_M_right);
    }
    static _Const_Link_type _S_right(_Const_Base_ptr __x)
    {
        return static_cast<_Const_Link_type>(__x->_M_right);
    }
    static const_reference _S_value(_Const_Base_ptr __x)
    {
        return static_cast<_Const_Link_type>(__x)->_M_value_field;
    }
    static const _Key& _S_key(_Const_Base_ptr __x)
    {
        return _KeyOfValue()(_S_value(__x));
    }
public:
    typedef _Rb_tree_iterator<value_type> iterator;
    typedef _Rb_tree_const_iterator<value_type> const_iterator;
private:
    iterator _M_insert_(_Const_Base_ptr __x, _Const_Base_ptr __y, const value_type& __v);
    iterator _M_lower_bound(_Link_type __x, _Link_type __y, const _Key& __k);
public:
    _Rb_tree()
    {
    }
    iterator begin()
    {
        return iterator(static_cast<_Link_type> (this->_M_impl._M_header._M_left));
    }
    iterator end()
    {
        return iterator(static_cast<_Link_type>(&this->_M_impl._M_header));
    }
    size_type size() const
    {
        return _M_impl._M_node_count;
    }
    pair<iterator, bool> _M_insert_unique(const value_type& __x);
    iterator _M_insert_unique_(const_iterator __position, const value_type& __x);
    iterator find(const key_type& __k);
    iterator lower_bound(const key_type& __k)
    {
        return _M_lower_bound(_M_begin(), _M_end(), __k);
    }
};
template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc> typename _Rb_tree<_Key, _Val, _KeyOfValue, _Compare, _Alloc>::iterator _Rb_tree<_Key, _Val, _KeyOfValue, _Compare, _Alloc>:: _M_insert_(_Const_Base_ptr __x, _Const_Base_ptr __p, const _Val& __v)
{
    _Link_type __z = _M_create_node((__v));
}
template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc> typename _Rb_tree<_Key, _Val, _KeyOfValue, _Compare, _Alloc>::iterator _Rb_tree<_Key, _Val, _KeyOfValue, _Compare, _Alloc>:: _M_lower_bound(_Link_type __x, _Link_type __y, const _Key& __k)
{
    while (__x != 0) if (!_M_impl._M_key_compare(_S_key(__x), __k)) __y = __x, __x = _S_left(__x);
}
template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc> pair<typename _Rb_tree<_Key, _Val, _KeyOfValue, _Compare, _Alloc>::iterator, bool> _Rb_tree<_Key, _Val, _KeyOfValue, _Compare, _Alloc>:: _M_insert_unique(const _Val& __v)
{
    _Link_type __x = _M_begin();
    _Link_type __y = _M_end();
    bool __comp = true;
    while (__x != 0)
    {
        __comp = _M_impl._M_key_compare(_KeyOfValue()(__v), _S_key(__x));
        __x = __comp ? _S_left(__x) : _S_right(__x);
    }
    iterator __j = iterator(__y);
    if (__comp)
    {
        if (__j == begin()) return pair<iterator, bool> (_M_insert_(__x, __y, (__v)), true);
        else --__j;
    }
    if (_M_impl._M_key_compare(_S_key(__j._M_node), _KeyOfValue()(__v))) return pair<iterator, bool> (_M_insert_(__x, __y, (__v)), true);
    return pair<iterator, bool>(__j, false);
}
template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc> typename _Rb_tree<_Key, _Val, _KeyOfValue, _Compare, _Alloc>::iterator _Rb_tree<_Key, _Val, _KeyOfValue, _Compare, _Alloc>:: _M_insert_unique_(const_iterator __position, const _Val& __v)
{
    if (__position._M_node == _M_end())
    {
        if (size() > 0 && _M_impl._M_key_compare(_S_key(_M_rightmost()), _KeyOfValue()(__v))) return _M_insert_(0, _M_rightmost(), (__v));
        else return _M_insert_unique((__v)).first;
    }
    else if (_M_impl._M_key_compare(_KeyOfValue()(__v), _S_key(__position._M_node)))
    {
        const_iterator __before = __position;
        if (__position._M_node == _M_leftmost()) return _M_insert_(_M_leftmost(), _M_leftmost(), (__v));
        else if (_M_impl._M_key_compare(_S_key((--__before)._M_node), _KeyOfValue()(__v)))
        {
            if (_S_right(__before._M_node) == 0) return _M_insert_(0, __before._M_node, (__v));
            else return _M_insert_(__position._M_node, __position._M_node, (__v));
        }
        else return _M_insert_unique((__v)).first;
    }
    else if (_M_impl._M_key_compare(_S_key(__position._M_node), _KeyOfValue()(__v)))
    {
        const_iterator __after = __position;
        if (__position._M_node == _M_rightmost()) return _M_insert_(0, _M_rightmost(), (__v));
        else if (_M_impl._M_key_compare(_KeyOfValue()(__v), _S_key((++__after)._M_node)))
        {
            if (_S_right(__position._M_node) == 0) return _M_insert_(0, __position._M_node, (__v));
            else return _M_insert_(__after._M_node, __after._M_node, (__v));
        }
        else return _M_insert_unique((__v)).first;
    }
}
template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc> typename _Rb_tree<_Key, _Val, _KeyOfValue, _Compare, _Alloc>::iterator _Rb_tree<_Key, _Val, _KeyOfValue, _Compare, _Alloc>:: find(const _Key& __k)
{
    iterator __j = _M_lower_bound(_M_begin(), _M_end(), __k);
    return (__j == end() || _M_impl._M_key_compare(__k, _S_key(__j._M_node))) ? end() : __j;
}
template <typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> > > class map
{
public:
    typedef _Key key_type;
    typedef _Tp mapped_type;
    typedef std::pair<const _Key, _Tp> value_type;
    typedef _Compare key_compare;
private:
    typedef typename _Alloc::template rebind<value_type>::other _Pair_alloc_type;
    typedef _Rb_tree<key_type, value_type, _Select1st<value_type>, key_compare, _Pair_alloc_type> _Rep_type;
    _Rep_type _M_t;
public:
    typedef typename _Pair_alloc_type::pointer pointer;
    typedef typename _Rep_type::iterator iterator;
    iterator end()
    {
    }
    mapped_type& operator[](const key_type& __k)
    {
        iterator __i = lower_bound(__k);
        if (__i == end() || key_comp()(__k, (*__i).first)) __i = insert(__i, value_type(__k, mapped_type()));
    }
    iterator insert(iterator __position, const value_type& __x)
    {
        return _M_t._M_insert_unique_(__position, __x);
    }
    key_compare key_comp() const
    {
    }
    iterator lower_bound(const key_type& __x)
    {
        return _M_t.lower_bound(__x);
    }
};
template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key> > class set
{
public:
    typedef _Key key_type;
    typedef _Key value_type;
    typedef _Compare key_compare;
private:
    typedef typename _Alloc::template rebind<_Key>::other _Key_alloc_type;
    typedef _Rb_tree<key_type, value_type, _Identity<value_type>, key_compare, _Key_alloc_type> _Rep_type;
    _Rep_type _M_t;
public:
    typedef typename _Key_alloc_type::pointer pointer;
    typedef typename _Rep_type::const_iterator iterator;
    iterator end() const
    {
    }
    std::pair<iterator, bool> insert(const value_type& __x)
    {
        std::pair<typename _Rep_type::iterator, bool> __p = _M_t._M_insert_unique(__x);
        return std::pair<iterator, bool>(__p.first, __p.second);
    }
    iterator find(const key_type& __x)
    {
        return _M_t.find(__x);
    }
};
typedef struct
{
}
div_t;
}
class base_pattern
{
public:
    virtual ~base_pattern()
    {
    }
};
extern "C" {
    typedef struct lua_State lua_State;
    extern "C" int (luaL_loadbuffer) (lua_State *L, const char *buff, size_t sz, const char *name);
}
class CLua;
class lua_call_throttle
{
public:
    lua_call_throttle(CLua *handle);
private:
    CLua *lua;
    typedef std::map<lua_State *, CLua *> lua_clua_map;
    static lua_clua_map lua_map;
};
class CLua
{
public:
    CLua(bool managed = true);
    lua_State *state();
    operator lua_State * ()
    {
        return state();
    }
    int execfile(const char *filename, bool trusted = false, bool die_on_fail = false, bool force = false);
    static int loadfile(lua_State *ls, const char *file, bool trusted = false, bool die_on_fail = false);
    static bool is_path_safe(std::string file, bool trusted = false);
    bool managed_vm;
    int mixed_call_depth;
private:
    lua_State *_state;
    typedef std::set<std::string> sfset;
    sfset sourced_files;
private:
    void init_lua();
};
class lua_text_pattern : public base_pattern
{
    ~lua_text_pattern();
private:
    bool translated;
    std::string pattern;
    std::string lua_fn_name;
};
extern CLua clua;
void cluaopen_globals(lua_State *ls);
bool file_exists(const std::string &name);
std::string datafile_path( std::string basename, bool croak_on_fail = true, bool test_base_path = false, bool (*thing_exists)(const std::string&) = file_exists);
class LineInput
{
};
class FileLineInput : public LineInput
{
public:
    FileLineInput(const char *name);
    bool eof()
    {
    };
    std::string get_line();
};
lua_State *CLua::state()
{
    if (!_state) init_lua();
}
int CLua::loadfile(lua_State *ls, const char *filename, bool trusted, bool die_on_fail)
{
    if (!is_path_safe(filename, trusted))
    {
    }
    std::string file = datafile_path(filename, die_on_fail);
    FileLineInput f(file.c_str());
    std::string script;
    while (!f.eof()) script += f.get_line() + "\n";
    return luaL_loadbuffer(ls, &script[0], script.length(), ("@" + file).c_str());
}
int CLua::execfile(const char *filename, bool trusted, bool die_on_fail, bool force)
{
    if (!force && sourced_files.find(filename) != sourced_files.end()) return 0;
    sourced_files.insert(filename);
    lua_State *ls = state();
    int err = loadfile(ls, filename, trusted || !managed_vm, die_on_fail);
    lua_call_throttle strangler(this);
}
void CLua::init_lua()
{
    cluaopen_globals(_state);
    execfile("dlua/util.lua", true, true);
}
lua_text_pattern::~lua_text_pattern()
{
    if (translated && !lua_fn_name.empty())
    {
        lua_State *ls = clua;
    }
}
lua_call_throttle::lua_call_throttle(CLua *_lua) : lua(_lua)
{
    if (!lua->mixed_call_depth++) lua_map[lua->state()] = lua;
}
